<template>
  <div class="trends-page">
    <div class="tway-title-hero" />
    <div :class="mobile ? 'pt-4' : ''" class="trends">
      <v-container fluid>
        <div v-if="desktop" class="tway-headline-3 title-desk">
          Conoce lo último en Transformación
        </div>
        <div v-if="mobile" class="tway-headline-3 mb-3 title-mobile">
          Lo último en Transformación Digital
        </div>
      </v-container>
      <v-container fluid>
        <v-layout row>
          <v-flex class="px-3" xs12 md4>
            <div style="font-size: 20px" class="tway-headline-3 mb-3">
              Actualidad
            </div>

            <div
              v-for="(current, n) in posts.current.slice(
                0,
                Math.floor(posts.current.length / 2)
              )"
              :key="current.id"
            >
              <card
                v-if="
                  current.flag == 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current"
              />
              <image-trend-post-card
                v-if="
                  current.flag != 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                class="mb-5"
                :post="current"
              />
              <horizontal-trend-post-card-getabstract
                v-if="
                  current.flag == 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current.source"
              />
              <image-trend-post-card-getabstract
                v-if="
                  current.flag != 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                class="mb-5"
                :post="current.source"
              />
            </div>
          </v-flex>
          <v-flex class="px-3" xs12 md4>
            <div class="tway-headline-3 white--text mb-3">.</div>
            <div
              v-for="(current, n) in posts.current.slice(
                Math.floor(posts.current.length / 2),
                posts.current.length + 1
              )"
              :key="current.id"
            >
              <card
                v-if="
                  current.flag == 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current"
              />
              <image-trend-post-card
                v-if="
                  current.flag != 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                class="mb-5"
                :post="current"
              />
              <horizontal-trend-post-card-getabstract
                v-if="
                  current.flag == 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current.source"
              />
              <image-trend-post-card-getabstract
                v-if="
                  current.flag != 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                class="mb-5"
                :post="current.source"
              />
            </div>
          </v-flex>
          <v-flex class="px-3" :class="mobile ? 'mb-15' : ''" xs12 md4>
            <div style="font-size: 20px" class="tway-headline-3 mb-3">
              Opinión
            </div>
            <div v-for="(current, n) in posts.opinion" :key="current.id">
              <card
                v-if="
                  current.flag == 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current"
              />
              <image-trend-post-card
                v-if="
                  current.flag != 'SMALL' && current.sourceType != 'GETABSTRACT'
                "
                class="mb-5"
                :post="current"
              />
              <horizontal-trend-post-card-getabstract
                v-if="
                  current.flag == 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                :left="n % 2 !== 0"
                class="mb-5"
                :post="current.source"
              />
              <image-trend-post-card-getabstract
                v-if="
                  current.flag != 'SMALL' && current.sourceType == 'GETABSTRACT'
                "
                class="mb-5"
                :post="current.source"
              />
            </div>
          </v-flex>
        </v-layout>
      </v-container>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.tway-badge {
  background: rgba(115, 25, 213, 0.1);
  color: #333333;
  border-radius: 45px;
  padding: 15px 23px;
  cursor: pointer;
}
.title-desk {
  width: 472px;
  height: 32px;
  left: 275px;
  top: 84px;

  /* Tway / H2 - Default */

  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 25px !important;
  line-height: 32px;
  /* identical to box height, or 128% */

  /* Tway / Gris Oscuro */

  color: #333333;
}

.title-mobile {
  font-family: Josefin Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 24px;
  line-height: 28px;
}
</style>

<script>
import HorizontalTrendPostCard from "@/components/trends/trends/HorizontalTrendPostCard";
import HorizontalTrendPostCardGetAbstract from "@/components/trends/trends/HorizontalTrendPostCardGetAbstract";
import ImageTrendPostCard from "@/components/trends/trends/ImageTrendPostCard";
import ImageTrendPostCardGetAbstract from "@/components/trends/trends/ImageTrendPostCardGetAbstract";
import TrendService from "@/services/trendService";
import CompanyService from "@/services/companyService";
import { mapActions, mapGetters } from "vuex";

const TRENDS_STEP = 3;
export default {
  name: "Trends",

  components: {
    card: HorizontalTrendPostCard,
    "horizontal-trend-post-card-getabstract":
      HorizontalTrendPostCardGetAbstract,
    "image-trend-post-card-getabstract": ImageTrendPostCardGetAbstract,
    ImageTrendPostCard,
  },

  data() {
    return {
      posts: {
        current: [],
        opinion: [],
        statistics: [],
        studies: [],
      },
      badges: [
        "Transformación",
        "Era Digital",
        "Economía Digital",
        "Industrias 4.0",
        "Orquestación",
        "Mindset Digital",
        "Tecnologías",
      ],
      codes: [26558, 13094, 14565, 25423, 31549],
    };
  },

  created() {
    let userSteps = this.getSteps;

    TrendService.getTrends()
      .then((trends) => {
        this.posts.opinion = trends.filter((e) => e.category == "COLUMN");
        this.posts.current = trends.filter((e) => e.category != "COLUMN");
        this.posts.current.sort((a, b) => {
          let d1 = new Date(a.createdOn);
          let d2 = new Date(b.createdOn);

          return d2 > d1 ? 1 : -1;
        });
        this.posts.opinion.sort((a, b) => {
          let d1 = new Date(a.createdOn);
          let d2 = new Date(b.createdOn);

          return d2 > d1 ? 1 : -1;
        });

        if (
          userSteps &&
          userSteps[TRENDS_STEP] &&
          !userSteps[TRENDS_STEP].active
        ) {
          this.activeTrends();
        }
      })
      .catch((err) => {
        this.$log.error(err);
      });
  },

  methods: {
    ...mapActions("UserStore", ["SET_STEP_ACTIVE"]),
    /* TODO: favor dejar de este PUT/POST general, se supone que es para modificar información del perfil de la compañia
     * pero se utiliza también para otros datos de actividad del usuario, se podria repensar la manera en que se manejan
     * estos datos, de momento se dejan dentro de la collection de compañias
     */
    activeTrends() {
      CompanyService.getCompanyProfile()
        .then((company) => {
          company.activity = { ...company.activity, trendsVisited: true };
          let companyPOST = {
            ...company,
            industrialSector: company.industrialSector
              ? company.industrialSector.name
              : null,
            industrialSectors: company.industrialSectors
              ? company.industrialSectors.map((is) => is.name)
              : null,
            dimensions: company.dimensions
              ? company.dimensions.map((d) => d.name)
              : null,
          };
          CompanyService.updateCompanyProfile(companyPOST)
            .then(() => this.SET_STEP_ACTIVE(TRENDS_STEP))
            .catch((err) => this.$log.error(err));
        })
        .catch((err) => console.log(err));
    },
  },

  computed: {
    ...mapGetters("UserStore", ["getSteps"]),
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
